pcl::GridMinimum< PointT > Class Template Reference
Module filters

GridMinimum assembles a local 2D grid over a given PointCloud, and downsamples the data. More...

`#include <pcl/filters/grid_minimum.h>`

Inheritance diagram for pcl::GridMinimum< PointT >:

## Public Member Functions

| GridMinimum (const float resolution)
| Empty constructor. More...
| ~GridMinimum ()
| Destructor. More...
void | setResolution (const float resolution)
| Set the grid resolution. More...
float | getResolution ()
| Get the grid resolution. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
| ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
| ~Filter ()
| Empty destructor. More...
const IndicesConstPtr | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

using | PointCloud = typename FilterIndices< PointT >::PointCloud

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Downsample a Point Cloud using a 2D grid approach. More...
void | applyFilter (std::vector< int > &indices) override
| Filtered results are indexed by an indices array. More...
void | applyFilterIndices (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

float | resolution_
| The resolution. More...
float | inverse_resolution_
| Internal resolution stored as 1/resolution_ for efficiency reasons. More...
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | Ptr = shared_ptr< FilterIndices< PointT > >
using | ConstPtr = shared_ptr< const FilterIndices< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

### template<typename PointT>
class pcl::GridMinimum< PointT >

GridMinimum assembles a local 2D grid over a given PointCloud, and downsamples the data.

The GridMinimum class creates a 2D grid over the input point cloud data. Then, in each cell (i.e., 2D grid element), all the points present will be downsampled with the minimum z value. This grid minimum can be useful in a number of topographic processing tasks such as crudely estimating ground returns, especially under foliage.

Author
  Bradley J Chambers

Definition at line 62 of file grid_minimum.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT >

using pcl::GridMinimum< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 70 of file grid_minimum.h.

## Constructor & Destructor Documentation

## GridMinimum()

template<typename PointT >

pcl::GridMinimum< PointT >::GridMinimum | ( | const float | resolution | ) |

inline

Empty constructor.

Definition at line 74 of file grid_minimum.h.

References pcl::Filter< PointT >::filter_name_, and pcl::GridMinimum< PointT >::setResolution().

## ~GridMinimum()

template<typename PointT >

pcl::GridMinimum< PointT >::~GridMinimum | ( |  | ) |

inline

Destructor.

Definition at line 81 of file grid_minimum.h.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT >

void pcl::GridMinimum< PointT >::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Downsample a Point Cloud using a 2D grid approach.

Parameters

  [out] | output | the resultant point cloud message

Implements pcl::FilterIndices< PointT >.

Definition at line 60 of file grid_minimum.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## applyFilter() [2/2]

template<typename PointT >

void pcl::GridMinimum< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 117 of file grid_minimum.h.

References pcl::GridMinimum< PointT >::applyFilterIndices().

## applyFilterIndices()

template<typename PointT >

void pcl::GridMinimum< PointT >::applyFilterIndices | ( | std::vector< int > & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 80 of file grid_minimum.hpp.

Referenced by pcl::GridMinimum< PointT >::applyFilter().

## getResolution()

template<typename PointT >

float pcl::GridMinimum< PointT >::getResolution | ( |  | ) |

inline

Get the grid resolution.

Definition at line 98 of file grid_minimum.h.

References pcl::GridMinimum< PointT >::resolution_.

## setResolution()

template<typename PointT >

void pcl::GridMinimum< PointT >::setResolution | ( | const float | resolution | ) |

inline

Set the grid resolution.

Parameters

  [in] | resolution | the grid resolution

Definition at line 89 of file grid_minimum.h.

References pcl::GridMinimum< PointT >::inverse_resolution_, and pcl::GridMinimum< PointT >::resolution_.

Referenced by pcl::GridMinimum< PointT >::GridMinimum().

## Member Data Documentation

## inverse_resolution_

template<typename PointT >

float pcl::GridMinimum< PointT >::inverse_resolution_

protected

Internal resolution stored as 1/resolution_ for efficiency reasons.

Definition at line 105 of file grid_minimum.h.

Referenced by pcl::GridMinimum< PointT >::setResolution().

## resolution_

template<typename PointT >

float pcl::GridMinimum< PointT >::resolution_

protected

The resolution.

Definition at line 102 of file grid_minimum.h.

Referenced by pcl::GridMinimum< PointT >::getResolution(), and pcl::GridMinimum< PointT >::setResolution().

The documentation for this class was generated from the following files:

- pcl/filters/grid_minimum.h
- pcl/filters/impl/grid_minimum.hpp